import { GraphAbstraction } from "../dtos";
export declare class GraphSchemaEntity {
    private readonly fullGraphAbstraction;
    private readonly ALIAS_INDEX;
    private readonly ABSTRACTION_INDEX;
    constructor(fullGraphAbstraction: GraphAbstraction);
    /**
     * It retuns a valid GraphAbstraction based on the original scheme.
     *
     *  @param {string|string[]} [selectedEntities] - it will filter the schema and return only the entities you need
     *  @param {boolean} [withRelationships=true] - it will tell the filter functionality to retrieve you the relationships for all nodes matching your selectedEntities
     */
    getAbstraction(selectedEntities?: string | string[], withRelationships?: boolean): GraphAbstraction;
    /**
     * It retuns a valid GraphAbstraction using a new set of properties, it will find for the original scheme and override the shceme with your properties defined on newSetOFAbstraction.
     *
     *  @param {GraphAbstraction} newSetOfAbstraction - used to override and add properties to the original schema
     *  @param {string|string[]} [selectedEntities] - it will filter the schema and return only the entities you need
     *  @param {boolean} [withRelationships=true] - it will tell the filter functionality to retrieve you the relationships for all nodes matching your selectedEntities
     */
    getAbstractionOverride(newSetOfAbstraction: GraphAbstraction, selectedEntities?: string | string[], withRelationships?: boolean): GraphAbstraction;
    private mergeAbstraciton;
    private getAbstractionCopy;
    private createNewAbstraction;
    private getRelationshipNames;
    private getOnlyNodeNames;
}
